/*
 *  UMMine.cpp
 *  
 *
 *  Created by devin delong on 5/25/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

//bzfs
#include "bzfsAPI.h"

//local
#include "UMMine.h"
#include "utility.h"

void ShockWaveMine::fire()
{
  //the mine does not exist anymore
  bz_fireWorldWep("SW", 2.0f, BZ_SERVER, pos.c_array(), 0, 0, kMineShotID+26, 0.0f);
}


void SphericalRegMine::fire()
{
  float dt = 0.25f;  
  //straight up
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/2, 0, kMineShotID, dt);  
  //straight down
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 3*M_PI/2, 0, kMineShotID+1, dt);
  
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 0, kMineShotID+2, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/4, kMineShotID+3, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/2, kMineShotID+4, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 3*M_PI/4, kMineShotID+5, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI, kMineShotID+6, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 5*M_PI/4, kMineShotID+7, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 3*M_PI/2, kMineShotID+8, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 7*M_PI/4, kMineShotID+9, dt);
  
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, 0, kMineShotID+10, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, M_PI/4, kMineShotID+11, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, M_PI/2, kMineShotID+12, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, 3*M_PI/4, kMineShotID+13, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, M_PI, kMineShotID+14, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, 5*M_PI/4, kMineShotID+15, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, 3*M_PI/2, kMineShotID+16, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), M_PI/4, 7*M_PI/4, kMineShotID+17, dt);
  
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, 0, kMineShotID+18, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, M_PI/4, kMineShotID+19, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, M_PI/2, kMineShotID+20, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, 3*M_PI/4, kMineShotID+21, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, M_PI, kMineShotID+22, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, 5*M_PI/4, kMineShotID+23, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, 3*M_PI/2, kMineShotID+24, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 7*M_PI/4, 7*M_PI/4, kMineShotID+25, dt);
}


void CylindricalRegMine::fire()  
{
  float dt = 0.25f;  
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 0, kMineShotID+27, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/4, kMineShotID+28, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/2, kMineShotID+29, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 3*M_PI/4, kMineShotID+30, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI, kMineShotID+31, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 5*M_PI/4, kMineShotID+32, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 3*M_PI/2, kMineShotID+33, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 7*M_PI/4, kMineShotID+34, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/6, kMineShotID+35, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, M_PI/3, kMineShotID+36, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 2*M_PI/3, kMineShotID+37, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 5*M_PI/6, kMineShotID+38, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 7*M_PI/6, kMineShotID+39, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 4*M_PI/3, kMineShotID+40, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 5*M_PI/3, kMineShotID+41, dt);
  bz_fireWorldWep("F", duration, BZ_SERVER, pos.c_array(), 0, 11*M_PI/6, kMineShotID+42, dt);
}

