/*
 *  utility.cpp
 *  
 *
 *  Created by devin delong on 5/25/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "utility.h"
#include "pow.hpp"

#include <cmath>

bool distanceLess(const boost::array<float, 3>& pos1,
                  const boost::array<float, 3>& pos2, 
                  float dist)
{
  return std::sqrt(pow_m<2>(pos1[0] - pos2[0]) + 
                   pow_m<2>(pos1[1] - pos2[1]) + 
                   pow_m<2>(pos1[2] - pos2[2])) < dist;
}


bool distanceLess(float pos1[3], float pos2[3], float dist)
{
  return std::sqrt(pow_m<2>(pos1[0] - pos2[0]) + 
                   pow_m<2>(pos1[1] - pos2[1]) + 
                   pow_m<2>(pos1[2] - pos2[2])) < dist;
}


namespace flag {
  
  bool isBadFlag(const std::string &flag)
  {
    if(flag.find("-") == std::string::npos)
      return false;
    return true;
  } 
  
  bool isSuperFlag(const std::string &flag)
  {
    if(flag.find("+") == std::string::npos)
      return false;
    return true;
  }
  
  bool isRedTeamFlag(const std::string &flag)
  {
    if(flag == DBZ_RED_TEAM || flag == "R*")
      return true;
    return false;
  }
  
  bool isBlueTeamFlag(const std::string &flag)
  {
    if(flag == DBZ_BLUE_TEAM || flag == "B*")
      return true;
    return false;
  }
  
  bool isPurpleTeamFlag(const std::string &flag)
  {
    if(flag == DBZ_PURPLE_TEAM || flag == "P*")
      return true;
    return false;
  }
  
  bool isGreenTeamFlag(const std::string &flag)
  {
    if(flag == DBZ_GREEN_TEAM || flag == "G*")
      return true;
    return false;
  }  
  
  bool isTeamFlag(const std::string &flag)
  {
    if(isRedTeamFlag(flag) ||
       isBlueTeamFlag(flag) ||
       isPurpleTeamFlag(flag) ||
       isGreenTeamFlag(flag))
      return true;
    
    return false;
  }
  
  bool isFlag(const std::string &toCheck, char const *flagAbbv)
  {
    if(toCheck.find(flagAbbv) == std::string::npos)
      return false;
    return true;
  }
  
  bool isFlag(const std::string &toCheck, const std::string &flagAbbv)
  {
    if(toCheck.find(flagAbbv) == std::string::npos)
      return false;
    return true;
  }
}
