/*
 *  utility.h
 *  
 *
 *  Created by devin delong on 5/25/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef UTILITY_H
#define UTILITY_H

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

//boost
#include <boost/array.hpp>

#include <string>

namespace flag {
  
  // Team flags
  #define DBZ_RED_TEAM "Red team flag"
  #define DBZ_GREEN_TEAM "Green team flag"
  #define DBZ_BLUE_TEAM "Blue team flag"
  #define DBZ_PURPLE_TEAM "Purple team flag"
    
  // Super flags
  #define DBZ_V "high speed (+V)"
  #define DBZ_QT "Quick Turn (+QT)"
  #define DBZ_OO "Oscillation Overthruster (+OO)"
  #define DBZ_F "rapid fire (+F)"
  #define DBZ_MG "Machine Gun (+MG)"
  #define DBZ_GM "Guided Missile (+GM)"
  #define DBZ_L "Laser (+L)"
  #define DBZ_R "Ricochet (+R)"
  #define DBZ_SB "Super Bullet (+SB)"
  #define DBZ_IB "Invisible Bullet (+IB)"
  #define DBZ_ST "STealth (+ST)"
  #define DBZ_T "Tiny (+T)"
  #define DBZ_N "Narrow (+N)"
  #define DBZ_SH "SHield (+SH)"
  #define DBZ_SR "SteamRoller (+SR)"
  #define DBZ_SW "Shock Wave (+SW)"
  #define DBZ_PZ "Phantom Zone (+PZ)"
  #define DBZ_G "Genocide (+G)"
  #define DBZ_JP "JumPing (+JP)"
  #define DBZ_ID "IDentify (+ID)"
  #define DBZ_CL "CLoaking (+CL)"
  #define DBZ_US "USeless (+US)"
  #define DBZ_MQ "MasQuerade (+MQ)"
  #define DBZ_SE "SEer (+SE)"
  #define DBZ_TH "THief (+TH)"
  #define DBZ_BU "BUrrow (+BU)"
  #define DBZ_WG "WinGs (+WG)"
  #define DBZ_A "Agility (+A)"
  #define DBZ_LG "Low Gravity (+LG)"
  
  // Bad flags
  #define DBZ_RC "ReverseControls (-RC)"
  #define DBZ_CB "ColorBlindness (-CB)"
  #define DBZ_O "Obesity (-O)"
  #define DBZ_LT "Left Turn only (-LT)"
  #define DBZ_RT "Right Turn only (-RT)"
  #define DBZ_FO "Forward Only (-FO)"
  #define DBZ_RO "ReverseOnly (-RO)"
  #define DBZ_M "Momentum (-M)"
  #define DBZ_B "Blindness (-B)"
  #define DBZ_JM "JaMming (-JM)"
  #define DBZ_WA "Wide Angle (-WA)"
  #define DBZ_NJ "No Jumping (-NJ)"
  #define DBZ_TR "TRigger happy (-TR)"
  #define DBZ_BY "BouncY (-BY)"
  
  bool isBadFlag(const std::string &flag);
  bool isSuperFlag(const std::string &flag);
  bool isRedTeamFlag(const std::string &flag);
  bool isBlueTeamFlag(const std::string &flag);
  bool isPurpleTeamFlag(const std::string &flag);
  bool isGreenTeamFlag(const std::string &flag);
  bool isTeamFlag(const std::string &flag);
  bool isFlag(const std::string &toCheck, char const *flagAbbv);
  bool isFlag(const std::string &toCheck, const std::string &flagAbbv);
  
}


bool distanceLess(const boost::array<float, 3>& pos1,
                  const boost::array<float, 3>& pos2, 
                  float dist);

bool distanceLess(float pos1[3], float pos2[3], float dist);


#endif /* UTILITY_H */


